#ifndef KV_H
#define KV_H

/* a key-value pair (can be linked in list) */
typedef struct kv_s kv_t;
struct kv_s {
	char *key;
	char *value;
	kv_t *next;
};

/* a list of key-value pairs */
typedef struct kvlist_s {
	kv_t *head, *tail;
	int len;
} kvlist_t;

/* append item to the list; if list is NULL, allocate a new list */
kvlist_t *kvlist_append(kvlist_t *list, kv_t *item);

/* free all items and the list */
void kvlist_free(kvlist_t *list);

/* allocate a new kv; key and value must be NULL or strclone()'d because 
   kb() does not malloc() key or value, just copies the pointer while kvlist_free()
   will free them! */
kv_t *kv(char *key, char *value);

#endif
