#ifndef PIPE_H
#define PIPE_H
#include "process.h"


int pipe_register(fd_t *from, fd_t *to);

/* kill an existing pipe. Normally you don't ever need this; it's used
   for vp env, because there we need to rewire connections from VP env
   to RP _env. Slow. */
void pipe_kill(pipe_t *pipe);

/* remove all pipes without really killing them - useful as a last step of uninit */
void pipe_uninit(void);

/* take a pipe and replace either src or sink with a different fd; the new
   fd is removed from its original pipe */
void pipe_rebind(pipe_t *pipe, fd_t *src, fd_t *sink);

/* unbind pipe from proc */
void pipe_unbind(pipe_t *pipe, proc_virt_t *p);

/* count the number of fds still having read-buffer (after hup) */
int pipe_count_rb(void);

#endif
